unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WSocket, WSocketS;

type
  TForm1 = class(TForm)
    SocketServeur: TWSocketServer;
    ListBox1: TListBox;
    procedure SocketServeurClientConnect(Sender: TObject;
      Client: TWSocketClient; Error: Word);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
type

  TUser = class(TWSocketClient)
  public
    procedure SocketDataAvailable(Sender: TObject; Error: Word);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TUser.SocketDataAvailable(Sender: TObject; Error: Word);
var
  CodeMessage,i,j:Integer;
  MessageRecu,MessageEnvoye:String;
  Users:TUser;
begin
  MessageRecu:=ReceiveStr;
  CodeMessage:=StrToInt(copy(MessageRecu,1,2));
  MessageRecu:=copy(MessageRecu,4,length(MessageRecu)-3);
  case CodeMessage of
  // Cas 10: On demande la liste des clients ...
  //2 cas : 1) On envoie toutes la liste au client qui vient juste de se connecter
  //        2) On envoie juste le dernier client connect aux autres clients dj en ligne
  10:begin
       Form1.ListBox1.Items.Add(MessageRecu);
       MessageRecu:='';
       for i:=0 to Form1.SocketServeur.ClientCount-1 do
       begin
         Users:=TUser(Form1.SocketServeur.Client[i]);
         // Envoie de la liste des clients au nouveau connect
         if Users=Self then
         begin
           for j:=0 to Form1.ListBox1.Items.Count-1 do
           begin
             MessageEnvoye:=Form1.ListBox1.Items.Strings[j];
             Users.SendStr('10-'+MessageEnvoye);
             Users.ProcessMessages;
           end;
         end
         else
         // Envoie juste le client qui vient de se connect au autre client connect
         begin
           MessageEnvoye:=Form1.ListBox1.Items.Strings[Form1.ListBox1.Items.count-1];
           Users.SendStr('10-'+MessageEnvoye);
           Users.ProcessMessages;
         end;
       end;
     end;
  end;
end;

procedure TForm1.SocketServeurClientConnect(Sender: TObject;
  Client: TWSocketClient; Error: Word);
  var
  User:TUser;
begin
  User:=TUser(Client);
  With User do
  begin
  OnDataAvailable:=SocketDataAvailable;
  LineMode            := FALSE;
  LineEdit            := FALSE;
  LineEnd  := #13#10;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SocketServeur.Addr:='0.0.0.0';
  SocketServeur.Port:='34598';
  SocketServeur.ClientClass:=TUser;
  SocketServeur.Listen;
end;

end.
