unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WSocket, StdCtrls, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    SocketClient: TWSocket;
    BtnConnexion: TButton;
    BtnDeconnexion: TButton;
    BtnEnvoieMessage: TButton;
    MessageAEnvoyer: TMemo;
    Label1: TLabel;
    ListBox1: TListBox;
    Label2: TLabel;
    Edit1: TEdit;
    procedure BtnConnexionClick(Sender: TObject);
    procedure BtnDeconnexionClick(Sender: TObject);
    procedure BtnEnvoieMessageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SocketClientSessionConnected(Sender: TObject; ErrCode: Word);
    procedure SocketClientDataAvailable(Sender: TObject; ErrCode: Word);
    procedure SocketClientSessionClosed(Sender: TObject; ErrCode: Word);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;


var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BtnConnexionClick(Sender: TObject);
begin
 SocketClient.Addr:='192.168.1.2';
 SocketClient.Port:='34598';
 SocketClient.Connect;
end;

procedure TForm1.BtnDeconnexionClick(Sender: TObject);
begin
  SocketClient.Close;
end;

procedure TForm1.BtnEnvoieMessageClick(Sender: TObject);
begin
  SocketClient.SendStr(MessageAEnvoyer.Text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BtnConnexion.Enabled:=true;
  BtnDeconnexion.Enabled:=false;
  MessageAEnvoyer.Enabled:=false;
  BtnEnvoieMessage.Enabled:=false;
end;

procedure TForm1.SocketClientSessionConnected(Sender: TObject;
  ErrCode: Word);
begin
  BtnConnexion.Enabled:=false;
  BtnDeconnexion.Enabled:=true;
  MessageAEnvoyer.Enabled:=true;
  BtnEnvoieMessage.Enabled:=true;
  // Envoie le pseudo au serveur afin d'avertir les autres clients
  SocketClient.SendStr('10-'+Edit1.Text);
end;

procedure TForm1.SocketClientDataAvailable(Sender: TObject; ErrCode: Word);
  var
  CodeMessage:Integer;
  MessageRecu:String;
begin
  MessageRecu:='';
  MessageRecu:=SocketClient.ReceiveStr;
  CodeMessage:=StrToInt(copy(MessageRecu,1,2));
  MessageRecu:=copy(MessageRecu,4,length(MessageRecu)-3);
  ShowMessage(MessageRecu);
  case CodeMessage of
  // Cas 10: Ajout d'un ou de plusieurs clients ...
  10:Begin
     ListBox1.Items.Add(MessageRecu);
     end;
  end;
end;

procedure TForm1.SocketClientSessionClosed(Sender: TObject; ErrCode: Word);
begin
  BtnConnexion.Enabled:=true;
  BtnDeconnexion.Enabled:=false;
  MessageAEnvoyer.Enabled:=false;
  BtnEnvoieMessage.Enabled:=false;
end;

end.
